#pragma once

#include <cgv/data/ref_ptr.h>
#include <cgv/base/base.h>
#include <cgv/base/lib_begin.h>

#ifdef WIN32
#pragma warning (disable:4251)
#endif

namespace cgv {
	namespace base {

class CGV_API named;

/// ref counted pointer to a node
typedef data::ref_ptr<named,true> named_ptr;

/** base class for all gui types */
class CGV_API named : public base
{
protected:
	/// store a pointer to the parent node
	const char* name;
public:
	/// construct from name
	named(const char* name);
	/// return the parent node
	const char* get_name() const;
	/// set a new parent node
	void set_name(const char* name);
	/// cast upward to named
	named* get_named();
	/// overload to return the type name of this object
	const char* get_type_name() const;
};

#ifdef WIN32
CGV_TEMPLATE template class CGV_API data::ref_ptr<named>;
#endif

	}
}

#include <cgv/config/lib_end.h>