#include <cgv/base/node.h>

namespace cgv {
	namespace base {


/// construct from name
node::node(const char* name) : named(name)
{
}

/// return the parent node
node_ptr node::get_parent() const
{
	return parent;
}

/// set a new parent node
void node::set_parent(node_ptr _parent)
{
	parent = _parent;
}

/// cast upward to node
node* node::get_node()
{
	return this;
}


/// overload to return the type name of this object
const char* node::get_type_name() const
{
	return "node";
}

	}
}
