#pragma once

#include <cgv/data/ref_ptr.h>
#include <cgv/base/named.h>
#include <cgv/base/lib_begin.h>

#ifdef WIN32
#pragma warning (disable:4251)
#endif

namespace cgv {
	namespace base {

class CGV_API node;

/// ref counted pointer to a node
typedef data::ref_ptr<node,true> node_ptr;

/** The node class keeps a pointer to its parent */
class CGV_API node : public named
{
protected:
	/// store a pointer to the parent node
	node_ptr parent;
public:
	/// construct from name
	node(const char* name);
	/// return the parent node
	node_ptr get_parent() const;
	/// set a new parent node
	void set_parent(node_ptr _parent);
	/// cast upward to node
	node* get_node();
	/// overload to return the type name of this object
	const char* get_type_name() const;
};

#ifdef WIN32
CGV_TEMPLATE template class CGV_API data::ref_ptr<node>;
#endif

	}
}

#include <cgv/config/lib_end.h>