#pragma once

#include <cgv/base/traverser.h>
#include <cgv/gui/event.h>

#include <cgv/gui/lib_begin.h>

namespace cgv {
	namespace gui {

/// interface for all classes that want to receive events
class CGV_API event_handler : public base::traverse_policy
{
public:
	/// default construction
	event_handler();
	/// grab the focus in all parent nodes
	bool grab_focus();
	/// overload and implement this method to handle events
	virtual bool handle(event& e) = 0;
	/// overload to stream help information to the given output stream
	virtual void stream_help(std::ostream& os) = 0;
};

	}
}

#include <cgv/config/lib_end.h>