#pragma once

#include <cgv/gui/events.h>
#include <cgv/gui/fltk/fltk_event_handler.h>

#include <cgv/gui/fltk/lib_begin.h>

namespace cgv {
	namespace gui {
		namespace fltk {

class CGV_API event_source : 
	virtual public named_object, 
	public event_base
{
	fltk_event_handler* receiver;
protected:
	event_source();
	fltk_event_handler::Result emit(int event) const;
	template <typename T>
	fltk_event_handler::Result emit(int event, const T& v) const;

public:
	void set_receiver(fltk_event_handler* _receiver);
	virtual void on_set_receiver();
};


template <typename T>
inline fltk_event_handler::Result event_source::emit(int event, const T& v) const 
{
	if (receiver) {
		event_data<T>() = v;
		return receiver->handle_event(event); 
	}
	return NOT_HANDLED;
}

		}
	}
}

#include <cgv/config/lib_end.h>