#include <cgv/base/linker.h>
#include <cgv/gui/fltk/trigger_server.h>
#include <fltk/run.h>

namespace cgv {
	namespace gui {
		namespace fltk {

struct timeout_info
{
	trigger* trig;
	trigger_server* ts;
};

void timeout_handler(void* _trig)
{
	trigger* trig = (trigger*) _trig;
	trig->shoot(::fltk::get_time_secs(), trig->get_delay());
	if (trig->is_recuring())
		::fltk::repeat_timeout((float)trig->get_delay(), timeout_handler, trig);
}

void trigger_server::schedule_on_shot(trigger* t, double delay)
{
	::fltk::add_timeout((float)delay,timeout_handler,t);
}

void trigger_server::schedule_recuring(trigger* t, double delay)
{
	::fltk::add_timeout((float)delay,timeout_handler,t);
}

void trigger_server::stop(trigger* t)
{
	::fltk::remove_timeout(timeout_handler,t);
}

struct register_server : public base::force_link
{
	register_server(const char* name)
	{
		if (!get_trigger_server())
			set_trigger_server(new trigger_server());
	}
};

register_server trig_serv("dummy");

		}
	}
}