#pragma once

//#pragma warning(disable:4311)
#pragma warning(disable:4251)

#include <cgv/base/register.h>
#include <cgv/gui/event_handler.h>
#include <cgv/gui/fltk/gl_view.h>
#include <fltk/Window.h>
#include <fltk/Item.h>
#include <fltk/ItemGroup.h>
#include <fltk/MenuBuild.h>

#include <cgv/gui/fltk/lib_begin.h>

namespace cgv {
	namespace gui {
		namespace fltk {

class CGV_API viewer : 
	public ::fltk::Window, 
	public base::abst_registration_listener
{
public:
	/// construct application
	viewer(int w, int h, const char* name);
	/**@name event_handler interface*/
	//@{
	/// overload and implement this method to handle events
	bool handle(event& e);
	/// overload to stream help information to the given output stream
	void stream_help(std::ostream& os);
	//@}

	/// start the timer callback
//	void start();
	/// static timer_event callback for fltk, which just calls the timer_event method
//	static void timeout_callback(void* this_ptr) { ((viewer*) this_ptr)->timer_event(); }
	/// compute time and time difference in timer_event event and call the animate method
//	void timer_event();
	/// return the view
	gl_view_ptr get_view() { return view; }
	/// interface of adding a factory
	void register_factory(cgv::base::abst_factory* factory, const char* item_text, char shortcut);
	/// interface of adding an object
	void register_object(cgv::base::base_ptr object);
	/// run the main loop
	int run();
protected:
	/// number of times the timer_event event is triggered per second
	double fps;
	/// global
	double time;
	///
	std::vector<cgv::base::abst_factory*> factories;

	::fltk::ItemGroup* create_item_group;
	/// number of times the timer_event event is triggered per second
	gl_view_ptr view;
	::fltk::MenuBar* menu;
	static void create_cb(::fltk::Widget* w, void* user_data);
private:
	/// store last clock value to be able to compute time difference to last frame
	double last_clock;
};

		}
	}
}

#include <cgv/config/lib_end.h>