#include <cgv/media/font/font.h>
#include <cgv/media/font/font_server.h>

namespace cgv {
	namespace media {
		namespace font {

/// construct from attributes
font_face::font_face(int _ffa) : ffa(_ffa) 
{
}
/// virtual destructor for ref_ptr support
font_face::~font_face()
{
}
/// return the attributes
int font_face::get_attributes() const
{
	return ffa;
}


/// virtual destructor for ref_ptr support
font::~font()
{
}

/// find an installed font by name
font_ptr find_font(const std::string& font_name)
{
	if (get_font_server())
		return get_font_server()->find_font(font_name);
	return font_ptr();
}

/// enumerate the names of all installed fonts
void enumerate_font_names(std::vector<const char*>& font_names)
{
	if (get_font_server())
		return get_font_server()->enumerate_font_names(font_names);
}

		}
	}
}