#include <cgv/media/text/convert.h>
#include <windows.h>
#include <Winnls.h>

namespace cgv {
	namespace media {
		namespace text {

std::wstring str2wstr(const std::string& s)
{
	std::wstring ws;
	ws.resize(s.size());
	int n = MultiByteToWideChar(CP_ACP,0,s.c_str(),(int)s.size(),&ws[0],(int)ws.size());
	ws.resize(n);
	return ws;
}

std::string wstr2str(const std::wstring& ws)
{
	std::string s;
	s.resize(4*ws.size());
	BOOL default_char_used;
	char default_char = '#';
	int n = WideCharToMultiByte(CP_ACP,0,ws.c_str(), (int)ws.size(),&s[0],(int)s.size(),&default_char, &default_char_used);
	s.resize(n);
	return s;
}

		}
	}
}
