#pragma once

#ifndef WIN32
#include <tr1/type_traits>
#endif

namespace cgv {
	namespace type {
		namespace cond {
/// template condition returning, whether the passed type has a virtual destructor
template <typename T>
struct has_virtual_destructor
{ 
	static const bool value = 
#ifdef WIN32
		__has_virtual_destructor(T); 
#else
		std::tr1::has_virtual_destructor<T>::value;
#endif
};
		}
	}
}
