#pragma once

#ifndef WIN32
#include <tr1/type_traits>
#endif

namespace cgv {
	namespace type {
		namespace cond {

/// template condition returning, whether the first argument is a base class of the second argument
template <typename base_type, typename derived_type>
struct is_base_of 
{ 
	static const bool value =  
#ifdef WIN32
			__is_base_of(base_type,derived_type);
#else
			std::tr1::is_base_of<base_type,derived_type>::value;
#endif
};

		}
	}
}
