#include <cgv/utils/date_time.h>
#include <time.h>

#pragma warning(disable:4996)

namespace cgv {
	namespace utils {

time_t convert_to_time(const date_time& dt)
{
	tm t;
	t.tm_sec = dt.sec;
   t.tm_min = dt.minutes;
	t.tm_hour = dt.h;   
	t.tm_mday = dt.day-1;   
	t.tm_mon = dt.month-1;    
	t.tm_year = dt.year;   
//	t.tm_wday;   
//	t.tm_yday;   
	return mktime(&t);
}

date_time convert_to_date_time(time_t ti)
{
	const tm& t = *gmtime(&ti);
	return date_time(time(t.tm_hour,t.tm_min,t.tm_sec),date(t.tm_year,t.tm_mon+1,t.tm_mday+1));
}

/// compute the difference of two points in time in seconds
long date_time::operator - (const date_time& dt) const
{
	return (long)convert_to_time(*this)-(long)convert_to_time(dt);
}

/// add given number of seconds to the point in time
date_time date_time::operator + (long secs) const
{
	return convert_to_date_time(convert_to_time(*this)+secs);
}

/// subtract given number of seconds to the point in time
date_time date_time::operator - (long secs) const
{
	return convert_to_date_time(convert_to_time(*this)-secs);
}

date_time now()
{
	return convert_to_date_time(::time(NULL));
}

	}
}
