#include <cgv/utils/dir.h>
#include <cgv/utils/file.h>

#ifdef WIN32
#include <direct.h>
#else
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#endif

namespace cgv {
	namespace utils {
		namespace dir {

bool exists(const std::string& dir_name)
{
	return file::find_first(dir_name+"\\*.*") != 0;
}

bool chdir(const std::string& dir_name)
{
#ifdef WIN32
	return _chdir(dir_name.c_str()) == 0;
#else
	std::cerr << "Not Implemented\n" << std::endl;
#endif
	return false;
}

bool mkdir(const std::string& dir_name)
{
#ifdef WIN32
	return _mkdir(dir_name.c_str()) == 0;
#else
	std::cerr << "Not Implemented\n" << std::endl;
#endif
	return false;
}

bool rmdir(const std::string& dir_name)
{
#ifdef WIN32
	return _rmdir(dir_name.c_str()) == 0;
#else
	std::cerr << "Not Implemented\n" << std::endl;
#endif
	return false;
}
std::string current()
{
#ifdef WIN32
	char buf[FILENAME_MAX];
	char * pbuf = _getcwd(buf,FILENAME_MAX);
	std::string s = (pbuf) ? buf : "";
#else
	std::string s;
	std::cerr << "Not Implemented\n" << std::endl;
#endif
	return s;
}
		}
	}
}
