#pragma once

#include <iostream>

namespace cgv {
	namespace utils {
/** progression provides a simple possibility to show progression of process in debug window */
struct progression
{
public:
	double next_shown;
	double next_step;
	double percent;
	double percent_step;
	int   enumerations;
	/// create empty progression
	progression() { enumerations = -1; }
	/// create from total enumerations and number of times to print progression
	progression(const char* process, unsigned int total, int count) { init(process, total, count); }
	/// reinitialize
	void init(const char* process, unsigned int total, int count) {
		if (count > 0) {
			std::cout << process << ":"; std::cout.flush();
			percent      = 0;
			enumerations = 0;
			next_shown   = next_step = (total-1.1)/count;
			percent_step = 100.0f/count;
		}
		else
			enumerations = -1;
	}

	/// next iteration
	void step() {
		if (enumerations < 0) 
			return;
		if (++enumerations > next_shown) {
			next_shown += next_step;
			percent   += percent_step;
			std::cout << " " << percent << "%";
			if (percent > 99.9f)
				std::cout << std::endl;
			else
				std::cout.flush();
		}
	}
};

	}
}