/*---------------------------------------------------------------------



----------------------------------------------------------------------*/
#pragma once
#include <memory>


namespace grid
{
	//
	// provides basic functionality for a 2d grid
	//
	template<class Derived>
	class BaseCell_2d
	{
	public:
		typedef Derived                                   this_t;


		// constructor
		BaseCell_2d()
		{
			memset( neighbours, 0, sizeof(this_t*)*8 );
		}

		// sets reference to the index-specified neighbour - may be null
		void setNeighbour( int neighbourIndex, this_t *neighbourCell )
		{
			neighbours[neighbourIndex] = neighbourCell;
		}

		// convinience function to access neighbours
		this_t *neighbour( int neighbourIndex )
		{
			return neighbours[neighbourIndex];
		}

		this_t *left()
		{
			return neighbours[0];
		}
		this_t *right()
		{
			return neighbours[1];
		}
		this_t *bottom()
		{
			return neighbours[2];
		}
		this_t *top()
		{
			return neighbours[3];
		}



	private:
		this_t                                        *neighbours[8]; // references to all 8 neighbouring cells (the full neighbourhood)
	};
}