/*---------------------------------------------------------------------



----------------------------------------------------------------------*/
#pragma once





namespace grid
{
	//
	//
	//
	class DiscreteCartesian_2d
	{
	public:
		typedef int                    component;

		// constructor
		DiscreteCartesian_2d( component i, component j ) : m_i(i), m_j(j)
		{
		}

		// returns first component of the 2d coordinate
		inline component i() const
		{
			return m_i;
		}

		// returns second component of the 2d coordinate
		inline component j() const
		{
			return m_j;
		}

		// convinience function to get neighbour coordinates
		DiscreteCartesian_2d topleft() const
		{
			return DiscreteCartesian_2d(m_i-1, m_j+1);
		}
		DiscreteCartesian_2d left() const
		{
			return DiscreteCartesian_2d(m_i-1, m_j);
		}
		DiscreteCartesian_2d topright() const
		{
			return DiscreteCartesian_2d(m_i+1, m_j+1);
		}

		DiscreteCartesian_2d right() const
		{
			return DiscreteCartesian_2d(m_i+1, m_j);
		}
		DiscreteCartesian_2d bottom() const
		{
			return DiscreteCartesian_2d(m_i, m_j-1);
		}
		DiscreteCartesian_2d bottomleft() const
		{
			return DiscreteCartesian_2d(m_i-1, m_j-1);
		}
		DiscreteCartesian_2d bottomright() const
		{
			return DiscreteCartesian_2d(m_i+1, m_j-1);
		}
		DiscreteCartesian_2d top() const
		{
			return DiscreteCartesian_2d(m_i, m_j+1);
		}

		// returns coord of index specified neighbour
		DiscreteCartesian_2d neighbourCoord( int neighbourIndex )
		{
			switch( neighbourIndex )
			{
			case 0:
				return left();
			case 1:
				return right();
			case 2:
				return bottom();
			case 3:
				return top();
			case 4:
				return topright();
			case 5:
				return bottomright();
			case 6:
				return bottomleft();
			case 7:
				return topleft();
			default:
				return DiscreteCartesian_2d(m_i, m_j);
			};
		}

	private:
		component                            m_i;
		component                            m_j;
	};
}