/*---------------------------------------------------------------------



----------------------------------------------------------------------*/
#pragma once

namespace grid
{
	//
	//
	//
	template<class Grid_2d>
	struct NearestNeighbourInterpolator_2d
	{
		typedef NearestNeighbourInterpolator_2d<Grid_2d>                       this_t;

		typedef typename Grid_2d::grid_coord_2d                         grid_coord_2d;
		typedef typename Grid_2d::cell_2d                                     cell_2d;


		template<class Value, class CoordComponent>
		float value( const Grid_2d &grid, CoordComponent x, CoordComponent y, Value val )
		{
			// coordinate of the cell in which the position is located
			grid_coord_2d coord( (int)floor( x ), (int)floor( y ) );

			// get value of coordinate specified cell cell
			return val( *grid.getCell(coord) );
		}
	};
}