/*---------------------------------------------------------------------

Defines a Custom Cell for the grid

----------------------------------------------------------------------*/
#pragma once

class CustomCell : public grid::BaseCell_2d<CustomCell>
{
public:
	CustomCell() : m_signedDistance( 1.0f )
	{
	}

	inline float signedDistance() const
	{
		return m_signedDistance;
	}
	inline float &signedDistance()
	{
		return m_signedDistance;
	}
private:
	float                  m_signedDistance;
};

// we have to provide a stream operator in order to be able to stream out the grid_2d
std::ostream& operator<<(std::ostream& os, const CustomCell &cell )
{
	float sd = cell.signedDistance();
	os.write( (char *)&sd, sizeof(float) );
	return os;
}

// we have to provide a stream operator in order to be able to stream in the grid_2d
std::istream& operator>>(std::istream& is, CustomCell &cell )
{
	is.read( (char *)&cell.signedDistance(), sizeof(float) );
	return is;
}

float &phi( CustomCell &cell )
{
	return cell.signedDistance();
}